function LL=LMM_ML_funct(s2)
 
% 20 April 2010
    
global tV tX tY count
 
s2=abs(real(s2));

if max(s2)>100
    LL=10^10;
	return
end

[n p]=size(tX);
nn=length(tV(:,1,1));

% assumes that there is independent residual variation
C=eye(nn);
for i=1:length(s2)
    C=C+s2(i)*tV(:,:,i);
end
 
invV=C\eye(nn);

b=(tX'*invV*tX)\(tX'*invV*tY);
H=(tY-tX*b);
s2e=(H'*invV*H)/(n-p);

% condensed LL
[cholC p]=chol(C);

if p==0
	logdetC=2*sum(log(diag(cholC)));
	logdetV=(n/nn)*logdetC;

	% condensed REML LL
	%LL=.5*((n-p)*log(s2e) + logdetV + log(det(tX'*invV*tX)) + (n-p));

	% condensed ML LL
	LL=.5*(n*log((n-p)*s2e/n) + logdetV + n);
else
    LL=10^10;
	logdetC=0;
end

% if mod(count,10)==0
% 	[LL logdetC s]
% end
% count=count+1;

